#include "16f76.h"
#include "lcd.h"
#include "iic-com.c"
#pragma config WDTE=off, FOSC=XT, PWRTE=on
#pragma bit clock_int @ PORTB.0
char temp;
char i;
void start_clock();
void stop_clock();
void set_clock();
void disp_clock(char clock_a);
void disp_set_ho(char poz);
void disp_term();
void disp_set_mi(char poz);
char set(char poz,char data,char max);
void set_temp_config();
int read_temp();
void disp_temp(char poz);
void wys_dec(char poz,char data);
void wys_dzies(char wartosc,char poz);
void delay_ms(char msek);

char time(char W)
{	
	skip(W);
	#pragma return[]="Time   :  :   "
}
char set_ho(char W)
{
	skip(W);
	#pragma return[]="set hours:    "
}
char set_mi(char W)
{
	skip(W);
	#pragma return[]="set minutes:  "
}  
char tem(char W)
{
	skip(W);
	#pragma return[]="Temperature   C"
}
	
void main()
{
int pom;	
	TRISC=0;//PORTC wyjciowy
	ADCON1=7;//PORTA wszystkie linie cyfrowe
	PORTB=0b00011000;//poczatkowe ustawienia PORTB dla magistrali I2C
	TRISB=0b11100111;	
	inic_lcd();//inicjalizacja moduu LCD 
	set_temp_config();//inicjalizacja termometru TCN75	
	temp=0;//wartoci pocztkowe wyliczania redniej z 4 pomiwrw
	i=0;
	disp_temp(0x40);//wywietlenie napisu "temperature"
	wys_dzies(read_temp(),0x4c);//wyswietlenie wartoci temperatury
	while(1){//ptla gwna
	while(clock_int==0)//czekanie na stan wysoki na clock_int
	{if((PORTA&7)!=7)//wejscie w ustawianie zegara po naciniciu klawisza
	 set_clock();}
	while(clock_int==1)//czekanie na stan niski (opadajce zbocze)
	{if((PORTA&7)!=7)//wejscie w ustawianie zegara po naciniciu klawisza
	 set_clock();}
	disp_clock(2);//wywietlenie czasu
	disp_term();//wyswietlenie redniej z 4 pomiarw
	}
}
//*********************************************************************
//procedura ustawiania licznikw zegara	PCF8583
//*********************************************************************
void set_clock()
{
	while((PORTA&7)!=7);
	delay_ms(50);
	stop_clock();
	read_IIC(2);//odczytanie licznika sekund, minut i godzin
	aa=0;//wyzerowanie licznika sekund
	disp_set_ho(0);//wyswietlenie ustawiania godzin
	cc=set(10,cc,24);//ustawianie godzin 0...23
	disp_set_mi(0);
	while((PORTA&7)!=7);
	delay_ms(50);
	bb=set(12,bb,60);//ustawianie minut 0....59
	write_IIC(2,3);
	start_clock();
	disp_clock(2);
	while((PORTA&7)!=7);
	delay_ms(100);	
}
//*********************************************************************
//zatrzymanie zegara
//*********************************************************************
void stop_clock()
{
	aa=0x80;
	write_IIC(0,1);
}
//*********************************************************************
//uruchomienie zegara
//*********************************************************************
void start_clock()
{
	aa=0;
	write_IIC(0,1);
}
//*********************************************************************
//ustawienie licznika, warto pocztkowa w data, wartoc maksymalna
//w max, pozycja na wyswietlaczu w poz
//*********************************************************************

char set(char poz,char data,char max)
{
char kod;
char j,d;
	j=data&0x0f;//jednostki (kod BCD)
	d=data>>4;//dziesiatki (kod BCD)
	data=(d*10)+j;//warto w kodzie bin
	while(1){	
	wys_dzies(data,poz);	
	delay_ms(240);
	while((PORTA&7)==7);
	delay_ms(50);
	kod=PORTA;
	kod=kod&0x07;
	if(kod==0x06)//kod UP
	{
	 ++data;
	 if(data==max)
	 --data;}
	if(kod==0x05)//kod DOWN
	{--data;
	 if(data==0xff)
	 ++data;}
	if(kod==0x03)//kod ACC
	break;
	}
	d=data/10;
	j=data-(d*10);
	data=d;
	data=data<<4;
	data=data|j;
	return(data);

}

void disp_set_ho(char poz)
{
char znak;
char i;

	pozycja(poz);  
	for(i=0;i<14;i++)
	{znak=set_ho(i);
	wr_data(znak);}
	
}
void disp_set_mi(char poz)
{
char znak;
char i;

	pozycja(poz);  
	for(i=0;i<14;i++)
	{znak=set_mi(i);
	wr_data(znak);}

}	
	
void disp_time(char poz)
{
char znak;
char i;

	pozycja(poz);  
	for(i=0;i<14;i++)
	{znak=time(i);
	wr_data(znak);}
}
//*********************************************************************'
//odczytanie i wyswietlenie licznika sekund, minut i godzin
//*********************************************************************
void disp_clock(char clock_a)
{
	disp_time(0);
	read_IIC(clock_a);
	wys_dec(5,cc);//godziny
	wys_dec(8,bb);//minuty
	wys_dec(11,aa);//sekundy

	
}
#pragma codepage 1

void disp_temp(char poz)
{
char znak;
char i;

	pozycja(poz);  
	for(i=0;i<15;i++)
	{znak=tem(i);
	wr_data(znak);}
}
//*********************************************************************
//odczytanie termometru, wyliczenie redniej z 4 pomiarw i wywietlenie
//sredniej
//*********************************************************************
void disp_term()
{
	temp=temp+read_temp();
	++i;
	if(i==4)
	{temp=temp/4;
	 wys_dzies(temp,0x4c);
	 temp=0;
	 i=0;}

}
//*********************************************************************
//odczytanie temperatury z TCN75
//*********************************************************************
int read_temp() 
{ 
int temp; 
  
 	temp=0; 
	startIICcomm();
    	sendIICbyte(0x90);
    	sendIICbyte(0);
    	stopIICcomm();

	startIICcomm();
	sendIICbyte(0x91);
	master_ack = 0;
        readIICbus();  temp = IIC_byte;
        master_ack = 1;
    	readIICbus(); 
    	stopIICcomm();
 	return(temp); 
 }
//*********************************************************************
//zapisanie rejestru konfiguracji TCN75
//*********************************************************************
 void set_temp_config() 
 {
	startIICcomm();
    	sendIICbyte(0x90);
	sendIICbyte(1);
	sendIICbyte(0x18);
	stopIICcomm();
}
//*********************************************************************
//wywietlenie dziesitnie liczby zapisanej w BCD
//*********************************************************************
void wys_dec(char poz,char data)
{

	pozycja(poz);
	wr_data((data>>4)+0x30);
	wr_data((data&15)+0x30);
}
//*********************************************************************
//wywietlenie dziesitne liczby zapisanej w kodzie BIN
//*********************************************************************
void wys_dzies(char wartosc,char poz)
{
char ldzies,ljedn;
	pozycja(poz); 
	ldzies=wartosc/10;
	wr_data(ldzies+0x30);
	ldzies=ldzies*10;
	wartosc=wartosc-ldzies;	
	wr_data(wartosc+0x30);
	
}
	

void pozycja(int poz)
{	
  wr_cmd(poz|0x80);//zapisz adres	
}

void inic_lcd()
{
	RW=0;
	delay_ms(50);//opoznienie 50msek
	RS=0;//rejestr IR
	EN=1;
	dane_lcd(3);//ustaw 3 na RA0...RA3
	EN=0;
	delay_ms(6);
	EN=1;
	#asm
	nop
	nop
	nop
	#endasm
	EN=0;
	delay_ms(1);
	EN=1;
	#asm
	nop
	nop
	nop
	#endasm
	EN=0;
	delay_ms(1);
	
	wr_cmd(0x28);//function set
	wr_cmd(8);//display off
	wr_cmd(1);//display clear
	wr_cmd(6);//entry mod
	wr_cmd(0x0c);//display on
}
void wr_cmd(int cmd)
{
	RS=0;
	wr_lcd(cmd);
}
void wr_data(int data)
{
	RS=1;
	wr_lcd(data);
}

void wr_lcd(int dana)
{
int TMP;
	TMP=dana;
	EN=1;	
	dane_lcd(TMP);//bardziej znaczacy polbajt
	EN=0;
	#asm
	nop;//wpisanie do modulu
	nop;
	#endasm
	EN=1;
	#asm
	swapf TMP,f;
	#endasm
	dane_lcd(TMP);//mniej znaczacy polbajt
	EN=0;
	if(RS==1)
	delay_ms(1);
	else
	delay_ms(3);
}
void dane_lcd(int dana)
{
	dana=dana&0xf0;
	PORTC=PORTC&0x0f;
	PORTC=PORTC|dana;
}

void delay_ms(char msek)
{
	OPTION=1;
	do{
	TMR0=0;
	while(TMR0<125)
	;}
	while(--msek>0);
	
	
}

