
////////////////////////////////////////////////////////////////////////////
//  Name    : Lampka samochodowa.c                                    	  //
//  Author  : [Krzysztof Pawsiuk]                                        //
//  Notice  : Copyright (c) 2002 		                                  //
//  Compil. : CCS PCM C Compiler, Version 3.045, 12391                    //
//  Date    : 2002-12-27                                                  //
//  Version : 1.0                                                         //
//  Notes   :                                                             //
//          :   			                                              //
////////////////////////////////////////////////////////////////////////////

#include <12f629.h>
#include <f629.h>

// 	BG1	BG0	 NC   NC  NC  CPD  CP BODEN MCLR PWRTE WDTE FOSC2 FOSC1 FOSC0
//  13  12   11   10   9   8   7    6    5    4     3     2   1      0
//   1	 1    0	   0   0   1   1    1    0    0     1     1   0      0
//  BG-HVolt             OFF  OFF   ON  PIN  ON    OFF   INTER RC

#rom 0x2007={0b11000111001100}	//wdt_off,pwrt_on,mclr_data,boden_on,lvp_of,cpt_of
#use delay(clock=4000000,restart_wdt)	//PROTECT->NOPROTECT,PUT->NOPUT
#id 1,2,0,2
#define drzwi	  gpio_0			//wejscie wlacznika drzwi, jesli=0 to otwarte, tzeba podciagnac do +
#define LED		  gpio_1	    	//wyjscie strowania dioda swiecaca if=1 to zapalona
#define BUZ		  gpio_2			//wyjscie sterowania tranzystorem BUZ10, if=1 to wlaczony
#define postojowe gpio_4			//wejscie swiatel postojowych jasji=1, to zapalone
#define stacyjka  gpio_5			//wejscie sygnalu ze stacyjki jesli 1, to stacyjka wlaczona

//#define Timer1_set   0x0000-62500 //500ms=62500*1us*8 ustawienia timera1 dla 0,5s
#define tmr1l_set 0xdc				//dane startowe dla timera 1
#define tmr1h_set 0x0b				//tl th =0x0000-62500=62500*8=500ms
#define czas	60					//czas swiecenia swiatla po otwarciu i zamknieciu drzwi
#define czas_long czas*4			//czas swiecenia swiatla przy otwartych drzwiach
int time;						    //odliczanie czasu wlaczenia i wylaczenia lampki
int post_time;						//odlicza czas pamieci zapalonych postojuwek
boolean post;
int i,j,k,l;
swiatlo();							//sprawdza warunki zapalenia swiatla

main()
{

osccal=0b10100000;
pcon=0;
setup_wdt(wdt_2304ms);				//konfiguracja wotchdog'a
trisio=0b11111001;					//ustawia port wejscia /wyjscia
bit_clear(option_reg,not_gppu);		//wlacza ogolne podciaganie do plusa
wpu=0x01;							//wlacza podciaganie dla gpio0
cmcon=7;							//port gp0,gp1,gp2 jako cyfrowe
post=0;								//zeruj znacznik postojowych
iocb=0;								//przerwania od zmiany portu wylaczone
buz=0;								//wylacza swiatlo
bit_set(option_reg,psa);			//preskaler do wdt
bit_clear(option_reg,t0cs);			//TMR0 z wewnetrznego zegara
tmr1l=tmr1l_set;					//ustaw poczatkowe wartosci tmr1
tmr1h=tmr1h_set;
t1con=0b00110101;					//tmr1 presk/8 start, internal
bit_set(pie1,tmr1ie);				//wlacza przerwanie od tmr1
intcon=0b11000000;					//wlacza przerwania globalne

while(1)
	{
	swiatlo();						//idz do obslugi sterowania swiatlem
	restart_wdt();

	}
}
/////////////////////////////////////////////////////////////////////////


//*******************************************************************************//
//Obsluga przerwania od tmr1 co 500ms											 //
//*******************************************************************************//
#INT_timer1
void wave_timer()
{

	tmr1l=tmr1l_set;				//ustaw timer1
	tmr1h=tmr1h_set;
	if(postojowe) post_time=0;		//jesli zapalone postojowe to zeruj czas
	if(++post_time>254) post_time=255;//jesli post_czas >254 to zapisz 255
	if(post_time<5) post=1;			//jesli czas<5 to postojowe byly zapalone
	else post=0;					//do 2sekund wczesniej, i ustaw flage post
	if(++time>254) time=255;		//jesli czas >254 to zapisz 255
	if(!stacyjka) led=~led;			//jesli stacyjka wylaczona to mrugaj dioda
	else   	led=0;					//jesli wlaczobna to zgas diode

 }
//*********************************************************************************//

///////////////////////////////////////////////////////////////////////////
//sprawdza czy wlaczona stacyjka z eliminacja drgan
char St_test()
{
	if(!stacyjka) return(0);
	delay_ms(100);
	if(stacyjka) return(1);
}
//-------------------------------------------------------------------------
////////sprawdza czy otwarto drzwi z eliminacja drgan
char drz_test()
{
	if(drzwi) return(1);
	delay_ms(100);
	if(!drzwi) return(0);
}

////////////////////////////////////////////////////////////////////////////
//sprawdza, czy swiatla pozycyjne sa zapalone z eliminacja drgan
char pos_test()
{
	if(!postojowe) return(0);
	delay_ms(100);
	if(postojowe) return(1);
}

//************************************************************************//

//************************************************************************//
//zapala swiatlo powoli rozjasniajac                                      //
//************************************************************************//
buz_on()
{//int i,j,k,l;

	j=255;i=0;
	for(k=0;k<255;k++)							//wykonaj 255 razy
		{
		 for(l=0;l<30;l++)						//wykonaj 30razy
		 { restart_wdt();						//zeruj WDT
		 	buz=0;								//wycz wiato
		 	tmr0=i;								//przepisz stan i do TMR0
		 	while(!bit_test(intcon,t0if));		//czekaj na przepenienie TMR0
		 	bit_clear(intcon,t0if);				//zeruj flag przepenienia TMR0
		 	buz=1;								//zapal wiato
		 	tmr0=j;								//przepisz stan j do TMR0
		 	while(!bit_test(intcon,t0if));		//czekaj na przepenienie TMR0
		 	bit_clear(intcon,t0if);				//zeruj flag przepenienia TMR0

		 }
		 i++;									//zwiksz warto i
		 j--;									//zmniejsz warto j
		 }										//jeli wszystko wykonane
		 buz=1;									//to wcz wiato

}
//************************************************************************//

//************************************************************************//
//gasi swiatlo powoli przyciemniajac                                      //
//************************************************************************//
buz_off()
{//int i,j,k,l;
	j=255;i=0;
	for(k=0;k<255;k++)							//wykonaj 255 razy
		{
		 for(l=0;l<50;l++)						//wykonaj 50razy
		 { restart_wdt();						//zeruj WDT
		 	buz=1;								//wcz wiato
		 	tmr0=i;								//przepisz stan i do TMR0
		 	while(!bit_test(intcon,t0if));		//czekaj na przepenienie TMR0
		 	bit_clear(intcon,t0if);				//zeruj flag przepenienia TMR0
		 	buz=0;								//zga wiato
		 	tmr0=j;								//przepisz stan j do TMR0
		 	while(!bit_test(intcon,t0if));		//czekaj na przepenienie TMR0
		 	bit_clear(intcon,t0if);				//zeruj flag przepenienia TMR0

		 }

		 i++;									//zwiksz warto i
		 j--;									//zmniejsz warto j
		 }										//jeli wszystko wykonane
		 buz=0;									//to wycz wiato
}
//************************************************************************//


//************************************************************************//
//  Procedura sterujaca lampka                                            //
//************************************************************************//
swiatlo()
{
drzwi_start:
//------------------Jesli stacyjka jest wylaczona-----------------------------
if(!st_test())							//jesli stacyjka jest wylaczona

	{

	 if(!drz_test()) 					//i drzwi sa otwarte
		{buz_on();						//stacyjka wylaczona to zapal swiatlo
drzwi_1:
		time=0;							//zeruj czas do wylaczenia swiatla
		while(time<czas_long&&!drz_test()) //czekaj dopuki nie minie czas lub zostana zamkniete drzwi
			{if(st_test()) goto drzwi_end;	//jesli stacyjka wlaczona to koniec
			restart_wdt();}
		time=0;							//jesli minal czas lub zamknieto drzwi
		while(time<czas&&!st_test())	//czekaj dopuki nie minie czas lub zostanie wlaczona stacyjka
			restart_wdt();
drzwi_end:
		buz_off();
		while(!drz_test());				//czekaj na zamkniecie drzwi
		return;
		}
	return;
	}
//------------------------------------------------------------------------
//-----------------------------jesli stacyjka jest wlaczona---------------
if(st_test())							//jesli stacyjka wlaczona
	{while(st_test())					//dopuki stacyjka wlaczona

		{if(!drz_test())				//jesli otwarto drzwi
			{buz_on();					//i swiec do momentu ich zamkniecia
			while(!drz_test())
				if(!st_test()) goto drzwi_1;
			buz_off();
	 	 	}
		}
     if(post)							//jesli minal czas lub zamknieto drzwi
     	{								//jesli wczeniej byly zapalone postojowe
	 	buz_on();
	 	time=0;
	 	while(time<czas&&!st_test()) 	//czekaj dopuki nie minie czas lub zostanie wlaczona stacyjka
    		{if(!drz_test()) goto drzwi_1; //jesli otwarto drzwi to idz do poczatku procedury
    		restart_wdt();}
    	buz_off();
    	return;
    	}

    }

}
//************************************************************************//

