
////////////////////////////////////////////////////////////////////////////
//  Name    : Zegar_termometr.c                                       	  //
//  Author  : [Krzysztof Pawsiuk]                                        //
//  Notice  : Copyright (c) 2003                                          //
//  Compil. : CCS PCM C Compiler, Version 3.045, 12391                    //
//  Date    : 2003-03-22                                                  //
//  Version : 1.0                                                         //
//  Notes   : OK.27.03.03                                                 //
//          :                                                             //
////////////////////////////////////////////////////////////////////////////
#include <16f628.h>
#include <f628.h>

#rom 0x2007={0b00000001010000}		//ustawienie bezpiecznikow
#use delay(clock=4000000)			//PROTECT->NOPROTECT,PUT->NOPUT
#id 0,3,0,3
//-----------------------------------------------------------------------------------
//ze wzgledu na ograniczonailosc pamieci programu, czesc komunikatow
//wyswietlanych na LCD zostalo zapisane w pamieci EEPROM
#define eeprom 0x2100
#define T1max 0 								//adres poczatkowy tekstu T1max=
#rom eeprom={'\r','T','1','m','a','x','=',0}	// 8 byte Napis T1max
#define T1min 8									//adres poczatkowy tekstu T1min=
#rom eeprom+8={'\n','T','1','m','i','n','=',0}	//8b-adr=16
#define T2max 16
#rom eeprom+16={'\r','T','2','m','a','x','=',0}	//8b-adr=24
#define T2min 24
#rom eeprom+24={'\n','T','2','m','i','n','=',0}	//8b-adr=32
#define ustawianie 32
#rom eeprom+32={'\r',' ',' ','U','s','t','a','w','i','a','n','i','e',
				' ','c','z','a','s','u','\n','g','g',':','m','m',':',
				'0','0',' ',' ','D','D','-','M','M','-','2','0','0','0', 0}//8b-adr=32

//-----------------------------------------------------------------------------------

#define timer1_set 8000						//1s dla kwarcu 32,768
#define OK_pin portb_4						//klawisz OK
#define UP_pin portb_5						//klawisz UP
#define DOWN_pin portb_2					//klawisz DOWN
#define ESC_pin porta_4						//klawisz ESC
#define UP 1								//przypisanie wartosci odpowiednim
#define OK 2								//klawiszom
#define DOWN 3
#define ESC 4
#define led portb_3							//port sterowania podswietlaniem
int key;									//bufor nacisnietego klawisza
int temp_status;							//okresla aktualny stan pomiaru temperatury
int duty;									//wypelnienie przebiegu sterujacego podswietlaniem
int led_on;									//
signed int16 temp1,temp1_min,temp1_max;    	//temperatura t1
signed int16 temp2,temp2_min,temp2_max;		//temperatura t2

int get_key();								//odczytuje stan klawiatury
get_temp(boolean ds,boolean dd);			//mierzy temp. z dwoch czujnikow
lcd_temp(signed int16 buf);					//wyswietla temperature w formacie xx.x*C
lcd_eeprom_text(byte adr);					//wyswietla na lcd dane z eeprom
#include <touch.c>							//obsluga 1wire
#include <lcd.h>							//obsluga LCD
#include<zegar.h>							//odmierzanie czasu

/////////////////////////////////MAIN/////////////////////////////////////////
main()
{int i;
cmcon=7;									//porta jako cyfrowy
pcon=0xff;
port_b_pullups(true);						//podciaganie dla RB
trisb=0b11110111;
led_on=0;									//wcza podswietlanie
lcd_init();									//inicjalizacja wyswietlacza LCD
lcd_znaki();								//Wpianie symbolu stopien do pamieci LCD
time_init();								//inicjalizacja odmierzania czasu
temp1_min=200;								//poczatkowe wrtosci temperatur
temp1_max=200;
temp2_min=200;
temp2_max=200;
t1con=0b00001011;							//timer1 z zewnetrznego kwarcu,preskaler/1
tmr1ie=1;									//wlacza przerwanie od t1
set_timer1(timer1_set);						//ustawienie wartosci poczatkowej timera t1
											//tmr1 pracuje przy polowie licznika, przerwanie nastapi co 1s

enable_interrupts(GLOBAL);					//wlacza globalne przerwania

//-----------konfiguracja PWM--------------------
//CCS
//setup_ccp1(CCP_PWM);   					// Configure CCP1 as a PWM
//set_timer2(0);
//setup_timer_2(T2_DIV_BY_16, 8, 1);		//(1/4000000)*4*16*10 =160us or 6.250 khz
//set_pwm1_duty(0);							//wycza podwietlanie
/////------------------------------------------------------------------
// To samo w ASM
pr2=9;										//ustala max liczbe PWM-tmr2 liczy do 9+1
ccpr1l=5;									//wpisuje wartosc, do ktorej RB3=1;
portb_3=0;									//port PB3 jako wyjscie
trisb_3=0;
T2CON=0b00000111;							//wlacza tmr2 z preskalerem/16
CCP1CON=0x0f;
//------------------------------------------------------------------------
duty=5;										//PWM=50%

while(1)
{

//Pomiar temperatury
if(temp_status==0)							//jesli temp_status=0 to wydanie polecenia
		{get_temp(0,0);						//do DS1820 o rozpoczeciu pomiaru
		 get_temp(1,0);						//dla czyjnika pierwszego i drugiego
		 temp_status=1;						//zwieksz status_temp, zeby wykonac tylko raz
		 }									//temp_starus jest zwiekszany ca 1sekunde w
if(temp_status==3)							//przerwaniu od TMR1, i jesli osiagnie 3, to
		{temp_status=0;						//nalezy odczytac temperature z czujnikow
		 get_temp(0,1);						//dla czujnika piewszego
		 get_temp(1,1);						//i dla drugiego
		 lcd_putc('\r');
		 lcd_gotoxy(2,1);					//wyswietl temperature 1
         lcd_temp(temp1);
	     lcd_gotoxy(2,14);					//wyswietl temperature 2
         lcd_temp(temp2);
		 }
lcd_gotoxy(1,1);							//wyswietl czas
printf(lcd_putc,"%2u:%02u:%02u  %02u-%02u-20%02u",godz,min,sek,dni,mies,lata);

get_key();									//sprawdz stan klawiatury
if(key==ok)
	{i=0;									//jesli klawisz OK, to mierz czas nacisniecia
	 while(get_key()==ok)
		{if(++i>120)						//jesli dluzej niz ok. 4s, to idz do
				{ustawczas();				//ustawiania czasu
				lcd_putc(cursoroff);		//po ustawieniu czasu wylacz kursor
				lcd_putc('\r');
				while(get_key()==ok);		//czekaj na zwolnienie klawisza OK
				goto time_end;
				}
	  	delay_ms(10);
		}
	led_on=~led_on;							//jesli klawisz nacisniety krotko,
	if(led_on) ccpr1l=duty;					//to przelacz stan podswietlania
	else ccpr1l=0;
	}

time_end:
//----------------------------------------------------------
if(key==esc)								//jesli nacisniety klawisz ESC, to
	{										//zwiekszaj intensywnosc podswietlania
	if(++duty>10) duty=0;
	 ccpr1l=duty;
	 if(ccpr1l>0) led_on=0xff;
	 else led_on=0;
	 delay_ms(300);
	 }
//--------------------------------------------------------
if(key==up)									//jesli nacisniety klawisz UP
	{										//to wyswietl wartosci min imax dla
t1:											//temperatury T1
	lcd_eeprom_text(T1max);					//wyswietla text z eeprom T1max=
	lcd_temp(temp1_max);
	lcd_eeprom_text(T1min);					//wyswietla text z eeprom T1min=
	lcd_temp(temp1_min);
	while(get_key()!=esc)					//jesli klawisz ESC, to powrot
		{if(key==ok)						//jesli klawisz OK, to kasowanie
			{temp1_min=temp1;				//Tmin i Tmax
			temp1_max=temp1;
			goto t1;}
		}
	 while(get_key()==esc);
	 lcd_putc('\r');
	 temp_status=0;							//pomiar temperatury od poczatku
	 }
//--------------------------------------------------------------
if(key==down)								//jesli klawisz DOWN, to
	{										//to wyswietl wartosci min imax dla
t2:											//temperatury T2
	lcd_eeprom_text(T2max);					//wyswietla text z eeprom T1max=
	lcd_temp(temp2_max);
	lcd_eeprom_text(T2min);					//wyswietla text z eeprom T1min=
	lcd_temp(temp2_min);
	while(get_key()!=esc)					//jesli klawisz ESC, to powrot
		{if(key==ok)						//jesli klawisz OK, to kasowanie
			{temp2_min=temp2;				//Tmin i Tmax
			temp2_max=temp2;
			goto t2;
			}
		}
	while(get_key()==esc);
	 lcd_putc('\r');
	  temp_status=0;						//pomiar temperatury od poczatku
	 }
}



}
////////////////////////////KONIEC MAIN//////////////////////////////////////

//************************************************************************//
// Wyswietla wartosc podana w parametrze w formacie xxx.x*C               //
//************************************************************************//
lcd_temp(signed int16 buf)
{
printf(lcd_putc,"%ld.%u%cC",buf/10,buf%10,0);
}
//************************************************************************//


//************************************************************************//
// procedura sprawdza, czy zostal nacisniety klawisz, jesli tak to zwraca //
// jego numer                      										  //
//************************************************************************//
int get_key()
{int temp;
key=0;
if(!ok_pin) key=ok;					//jesli nacisniety klawisz ok, to key=1
else if(!esc_pin) key=esc;			//jesli nacisniety klawisz esc, to key=2
else if(!down_pin) key=down;		//jesli nacisniety klawisz down, to key=3
else if(!up_pin) key=up;			//jesli nacisniety klawisz up, to key=4
else return(0);						//jesli zaden nie nacisniety to powrot
temp=key;							//jesli jednak nacisniety to zapisz wartosc do bufora
delay_ms(20);						//poczekaj 20ms i sprawdz czy dalej nacisniety
key=0;
if(!ok_pin) key=ok;					//jesli nacisniety klawisz ok, to key=1
else if(!esc_pin) key=esc;			//jesli nacisniety klawisz esc, to key=2
else if(!down_pin) key=down;		//jesli nacisniety klawisz down, to key=3
else if(!up_pin) key=up;			//jesli nacisniety klawisz up, to key=4
else return(0);						//jesli zaden nie nacisniety to powrot
if(temp==key) return(key);			//jesli dalej taki sam klawisz, to zwroc jego wartosc
else return(0);						//jesli nie to blad i zwroc 0
}
//************************************************************************//



//***************************************************************************************
//					Procedura odczytu temperatury z DS1820
//***************************************************************************************
get_temp(boolean ds,boolean dd)
{
byte i,buf[8];
boolean ds_ok;
signed int16 t,t1;
ds_ok=0;
if(!dd){										//jesli dd=0 to start pomiaru
	if(!ds)										//dla pierwszego czujnika
		{
	   if(touch_present())						//jesli zgosi obecnosc 1 uklad
	   		{									//to wyslij polecenie pomiaru
	   		touch_write_byte(0xCC);				//rozpoczecia pomiaru temperatury
	   		touch_write_byte(0x44);
			}
		}
	else										//jesli ds=1, to dla drugiego czujnika
		{
		if(touch1_present())					//jesli zgosi obecnosc 2 uklad
			{
			 touch1_write_byte(0xCC);			//to wyslij polecenie pomiaru
			 touch1_write_byte(0x44);			//rozpoczecia pomiaru temperatury
			}
		}
	}
else{											//jesli dd=1, to odczyt temperatury
	  if(!ds)									//jesli ds=0 to z pierwszego czujnika
	  	{
	   	touch_present();
	   	touch_write_byte(0xCC);
	   	touch_write_byte (0xBE);
	   	for(i=0;i<=7;i++)
	   	   buf[i]=touch_read_byte();
	  	ds_ok=1;								//ustaw znacznik nowej poprawnej temperatury
	  	}
	  else										//jesli ds=1 to z drugiego czujnika
		{touch1_present();
		touch1_write_byte(0xCC);
		touch1_write_byte (0xBE);
		for(i=0;i<=7;i++)
	   	   buf[i]=touch1_read_byte();
		ds_ok=1;								//ustaw znacznik nowej poprawnej temperatury
		}
if(ds_ok)										//jesli odebrano poprawnie temperature to oblicz
	   {T=make16(buf[1],buf[0]);				//jej wartosc i wpisz do buforow
	   if(bit_test(t,0)) t--;
	   t*=50;
	   t-=25;
	   t1=buf[7]-buf[6];
       t1*=100;
       t1/=buf[7];
       t+=t1;
	   t/=10;									//konwersja rozdzielczosci temperatury na 0,1*C
	if(!ds)										//jesli ds=0, to zapis zmierzonej do temp1
		{temp1=t;
		if(temp1>temp1_max) temp1_max=temp1;	//jesli zmierzona jest wieksza od max, to zapisz do max
		if(temp1<temp1_min) temp1_min=temp1;	//jesli zmierzona jest mniejsza od min, to zapisz do min
		 }
	else										//jesli ds=1, to zapis zmierzonej do temp2
		{temp2=t;
		 if(temp2>temp2_max) temp2_max=temp2;	//jesli zmierzona jest wieksza od max, to zapisz do max
		 if(temp2<temp2_min) temp2_min=temp2;	//jesli zmierzona jest mniejsza od min, to zapisz do min
	    }
	  }

	  }
}
//***************************KONIEC ODCZYTU TEMPERATURY***********************************


//************************************************************************//
// wyswietla text zapisany w eeprom do napotkania zera
//--------------------------------------------------------------------------
lcd_eeprom_text(byte adr)
{byte i,k;
	i=adr;
	do{k=read_eeprom(adr);
		if(k==0) break;
		printf(lcd_putc,"%C",k);
		adr++;
		}while(k!=0);
}
//**************************************************************************

