
////////////////////////////////////////////////////////////////////////////
//  Name    : ISD2560.h                                               	  //
//  Author  : [Krzysztof Pawsiuk]                                        //
//  Notice  : Copyright (c) 2002 	                                      //
//  Compil. : CCS PCM C Compiler, Version 3.045, 12391                    //
//  Date    : 2002-07-14                                                  //
//  Version : 1.0                                                         //
//  Notes   :                                                             //
//          :                                                             //
////////////////////////////////////////////////////////////////////////////
//gotowe procedury do obslugi ukladu ISD2560
//nalezy zdefiniowac piny podlaczone do ukladu
////-------------------Definicja pinow ukladu ISD2560----------------------------------------
#define eom	portb_0				//sygnal konca wiadomosci glosowej
#define MA0	portb_7				//sygnal przyspieszania odczytu wiadomosc
#define R_P	portb_2				//zapis zapis=1, odczyt=0
#define PD	portb_3				//power down ISD PD=0, ISD aktywny
#define CE	portb_4				// chip select, =0, uklad wybrany
#define wait 0					//przy odtwarzaniu procedura czeka na koniec komunikatu
#define nowait 1				//przy odtwarzaniu proceduta nie czeka na koniec komunikatu

//************************************************************************//
//   Start nagrywania od adresu 0 pamieci                                                   //
//************************************************************************//
isd25xx_rec_start()
{
       MA0=0;                 	//tryb narmalnej pracy
       PD=0;                  	//uaktywnij uklad ISD
       delay_ms(30);          	//czekaj na uruchomienie ukladu ISD
       R_P=0;                 	//ustaw jako zapis
       CE=0;                  	//rozpocznij nagrywanie
}
//************************************************************************//

//************************************************************************//
//      Powoduje zatrzymanie nagrywania                                   //
//************************************************************************//
ISD25xx_rec_pause()
{
	 CE=1;                  	//zatrzymaj nagrywanie
}
//************************************************************************//

//************************************************************************//
//      Ponowny start nagrywania, po zatrzymaniu, od aktualnego adresu    //
//************************************************************************//
ISD25xx_rec_next()
{
	 CE=0;                    	//rozpocznij nagrywanie kolejnego komunikatu
}
//************************************************************************//

//************************************************************************//
// Konczy proces nagrywania, uklad przechodzi w stan uspienia             //
// licznik pamieci jest zerowany
//************************************************************************//
ISD25xx_rec_stop()
{
 	CE=1;                  		//zatrzymaj nagrywanie
    PD=1;                  		//przelacz ISD w tryb uspienia
}
//************************************************************************//


//************************************************************************//
// Procedura umozliwia odczyt dowolnego komunikatu zawartego w pamieci    //
// bez znajomosci jego fizycznego adresu
//************************************************************************//
ISD25xx_play(int nr_kom, int wait_nowait)
{
	int i;
	if(nr_kom==0) return;			//jesli komunikat=0 to powrot, musi byc>0
    CE=1;		                    //nie wybieraj ukladu
    PD=1;                     		//ISD uspiony
	delay_ms(15);
    R_P=1;			                //przelacz w tryb odczytu
    PD=0;                      		//Isd aktywny
	Delay_ms(30);          			//czekaj na uruchomienie ukladu ISD
	disable_interrupts(global);		//wylacz przerwania
//sprawdz czy nr_kom>1 jesli tak to znajdz komunikat o podanym numerze i odtworz
//jesli nr_kom=1, to odtworz go, bez przeszukiwania
	while(nr_kom>1)
       {
        MA0=1;            			//przelacz w tryb turbo (*800)
        CE=0;			            //start komunikatu
        CE=1;
 		while(eom);					//czekaj na koniec komunikatu
    	while(!eom);				//czekaj na zwolnieni znacznika konca
       	nr_kom--;					//komunikatu i zmniejsz o 1 numer komunikatu
       	}
        MA0=0;               		//jesli ISD_numer=1 to adres w ISD jest na
        CE=0;                		//zadanym komunikacie odtworz z
        CE=1;						//normalna predkoscia
        if(wait_nowait==wait)		//jesli ma czekac na koniec komunikatu
		{	while(eom);	    		//to czekaj
		while(!eom);
		delay_us(10);
		pd=1;}						//wylacz uklad isd
enable_interrupts(global);			//jesli bez czekania na koniec, to powrot
}
//************************************************************************//

//************************************************************************//
//   wylacza odtwarzanie komunikatu                                                                     //
//************************************************************************//
isd25xx_play_stop()
{
	pd=1;
}
//************************************************************************//








