////////////////////////////////////////////////////////////////////////////
//  Name    :Nadajnik RC5_SIRC.c                                      	  //
//  Author  : [Krzysztof Pawsiuk]                                        //
//  Notice  : Copyright (c) 			                                  //
//  Compil. : CCS PCM C Compiler, Version 3.045, 12391                    //
//  Date    : 2002-12-29                                                  // 
//  Version : 1.0                                                         //
//  Notes   :                                                             //
//          :  Ok. 30.12.02                                               // 
////////////////////////////////////////////////////////////////////////////
#include <12f629.h>								//definicja rejestrow CCS 
#include <f629.h>								//definicja rejestrow asm		

// 	BG1	BG0	 NC   NC  NC  CPD  CP BODEN MCLR PWRTE WDTE FOSC2 FOSC1 FOSC0
//  13  12   11   10   9   8   7    6    5    4     3     2   1      0
//   1	 1    0	   0   0   1   1    1    0    0     1     0   1      0
//  BG-HVolt             OFF  OFF   ON  PIN  ON    OFF   hs  

#rom 0x2007={0b11000111000010}					//konfigoracja bezpiecznikow
#use delay(clock=20000000)						//definicja czestotliwosci zegara	
#use rs232(baud=9600, xmit=PIN_a0,rcv=pin_a2,invert)  
												//ustalenie predkosci i pinow przeznaczonych 
												//transmisji szeregowej
#id 1,2,0,2				            			//wpis 	

#include <rc5.h>								//wczytaj obsluge RC5
#include <sony.h>								//wczytaj obsluge SIRC	
#define enter	0x0D							//wartosc HEX klawisza enter 
#define led gpio_0								//deklaracja portu diody led
boolean sony_rc5;								//flaga systemu transmisji danych,jesli =1 to wysyla sony
//------------------------------------MAIN-------------------------------------//
main()
{int address,command;							//zmienne adresu i komendy wysylanych kodow 
int rsIn;										//tyczasowy bufor odbieranych danych z portu szeregowego
int bufRs[5];									//5-cio bajtowy bufor komendy i rozkazu
cmcon=7;										//wpis ustawia port jako cyfrowy
sony_init();									//inicjalizacja systemu SIRC
rc5_init();										//inicjalizacja systemu RC5
trisio=0b11111100;								//ustawia porty wejscia/wyjjscia
sony_rc5=0;										//ustawia nadawanie RC5
bufRs[0]=0;										//zeruj bufor komendy i adresu
bufRs[1]=0;
bufRs[2]=0;
bufRs[3]=0;
bufRs[4]=0;
led=1;											//zapal diode Led
delay_ms(1000);									//czekaj 1sekunde
led=0;											//zgas diode Led

start:	
while(1)										//glowna petla programu		
	{	
	if(kbhit())									//jesli start transmisji szergowej
		{rsIn=getc();							//to odbierz znak i wpisz do rsIn
	 	if(RsIn==enter)							//jesli znak = enter, to koniec wpisywania
	 		{									//komendy i trzeba wyslac podana komende		
			if(sony_rc5)						//jesli system ustawiony na SIRC, 
	 			{								//to dane wysylane sa w tym systemie
	 			address=bufRs[3]+bufRs[4]*10;	//trzeba przetworzyc dwa znaki ASCII adresu
	 			command=bufRs[0]+bufRs[1]*10;	//i trzy znaki komendy na jeden bajt adresu
	 			command+=BufRs[2]*100;			//i jeden bajt komendy
	 			sony_send(address,command);		//wyslij komende - wysyla dwa razy
	 			delay_ms(25);					//z przerwa 25ms, poniewaz
	 			sony_send(address,command);		//urzadzenia analizuja dwuktrotna transmisje	
	 			}
	 		else								//jesli system RC5, to zamien
	 			{
	 			address=bufRs[2]+bufRs[3]*10;   //dwa znaki ASCII adresu i dwa znaki komendy
	 			command=bufRs[0]+bufRs[1]*10;	//na jeden bajt adresu i i jeden bajt komendy
	 			rc5_send(address,command);		//wysli dane w systemie RC5	
	 			}
	 		putc('\r');							//wyslij do komputera informacje	
	 		if(sony_rc5) 						//zwrotna o wyslanej komendzie
	 			{putc('S');						//jesli dane zostaly wyslane w SIRC
	 			printf(" A=%02u K=%03u",address,command);}
	 		else 								//jesli dane zostaly wyslane w systemie RC5		
	 			{putc('R');
	 			printf(" A=%02u K=%02u",address,command);}
	 		
	 		}
	 	else									//jesli odbierany z RS232 znak nie jest enter
	 		{
	 		if(RsIn=='s'||RsIn=='S') 			 
	 			{sony_rc5=1;	            	//jesli odebrano znacznik kodu sony to ustaw flage
	 			 goto start;					//idz na poczatek procedury 	
	 			 }
	 		if(RsIn=='r'||RsIn=='R') 
	 			{sony_rc5=0;			    	//jesli odebrano znacznik kodu RC5 to zeruj flage
	 			goto start;						//idz na poczatek procedury 
	 			}
												//jesli odebrany znak nie jest rowny 's', 'S', 'r', 'R'		
	 		BufRs[4]=BufRs[3];					//to zapisz w buforze,przesuwa bajty w buforze w lewo
	 		BufRs[3]=BufRs[2];					//dzieki temu mozna odebrac duzo 
	 		BufRs[2]=BufRs[1];					//znakow, ale licza sie tylko 
	 		BufRs[1]=BufRs[0];					//4 ostatnie dla rc5, 5 dla sony
	 		BufRs[0]=rsIn&0x0f;					//zapisz odebrany znak w buforze i zamien na dziesietny

			}
		
		}

	}
}
//------------------------------KONIEC MAIN------------------------------------//

