#include "16f84.h"
#include "lcd.h"
#pragma config WDTE=off, FOSC=XT, PWRTE=on
#pragma bit RC5 @ PORTA.0
#pragma bit CL @PORTA.1
#pragma bit DQ @PORTA.2
#pragma bit RST @PORTA.3
#pragma bit SA @ PORTA.4
#pragma bit SB @ PORTB.0

long get_rc5();
int impulsator();
void wr_eeprom(char adres,char dana);
char rd_eeprom(char adres);
void wys_dzies(char wartosc,char poz);
void delay_ms(char msek);
void wys_volume(char poz);
void wr_pot(int vol);

char volume(char W)
{	
	skip(W);
	#pragma return[]="volume -  dB"
}
void main()
{
long kod;
char vol;
int kod1;
	TRISA=0x11;
	TRISB=1;
	inic_lcd();//inicjalizacja moduu LCD
	if(rd_eeprom(20)!=0x76)//pierwsze uruchomienie 
	{wr_eeprom(0,40);
	 wr_eeprom(20,0x76);}

	vol=rd_eeprom(0);//warto pocztkowa gonoci
	wr_pot(vol);
	wys_volume(0);
	while(1){
	wys_dzies(vol,8);//wywietlenie gonoci
	kod=impulsator();//czekanie na odbir kodu RC5 z pilota lub obrt osi
	kod1=kod;
	if(kod1==8)
	{++vol;
	 if(vol==65)
	 vol=64;}
	if(kod1==0)
	{--vol;
	 if(vol==0xff)
	 vol=0;}
	wr_pot(vol);
	wr_eeprom(0,vol);
	}
}
//**********************************************************************
//procedura odbierania kodu RC5. Na 8 starszych bitach zwracanego kodu 
//jest sowo systemu, a na 8 modszych sowo komendy
//**********************************************************************
long get_rc5()
{
int i,c_rc5;
bit inrc5;
long c_crc5;
	
	while(RC5==0);
	c_rc5=0;
	c_crc5=0;
	for(i=0;i<13;i++)
	{
	 if(RC5==0)
	 inrc5=0;
	 else
	 inrc5=1;
	OPTION=1;
	TMR0=0;//wyzerowanie licznika TMR0
	
	while(1)
	{
	  if(TMR0>125)
	   return (0);//powrt z bdem
	 
	  if((RC5==0)&&(inrc5==1))//opadajce zbocze?
	   {c_rc5=c_rc5<<1;
	    c_rc5=c_rc5|1;//wstaw 1
	    break;}
	  if((RC5==1)&&(inrc5==0))//narastajce zbocze?
	    {c_rc5=c_rc5<<1;//przesu i wstaw 0
	    break;}
	}
	if(i==6)
	{c_crc5=(c_rc5&0x5f);//6bitw adres
	c_crc5=c_crc5<<8;
	c_rc5=0;}
	OPTION=1;
	TMR0=0;//wyzerowanie licznika TMR0
	while(TMR0<125);//odczekanie 1ms
	}
	c_crc5=(c_crc5|c_rc5);//zapisanie komendy
	return(c_crc5);
}
//***************************************************************
//Procedura obsugi impulsatora, dodatkowo sprawdza stan linii RC5
//i jeeli jest niski to odbiera kod z pilota RC5. Procedura zwraca
//kod przycisnitego klawisza pilota RC5 lub kod impulsatora
//****************************************************************
int impulsator() 
{ 
long kod;
 	 
 	while(1){ 	
 _err:	if(RC5==0)
 	{kod=get_rc5();
	 if(kod==0)//bd kodu//sprawdznie czy nie odbir z RC5 
	 continue;
         else
	 return(kod);}
 	 
 	if(SA==1&&SB==0)//stan pocztkowy 
 	{
 	 delay_ms(4); 
 	 while(1) 
 	  { 
 	  if(SA==1&&SB==0) 
 	  {if(RC5==0)//sprawdznie czy nie odbir z RC5 
 	   {kod=get_rc5();
	   if(kod==0)//blad kodu
	   continue;
           else
	  return(kod);}

 	  continue;} 
 	  delay_ms(4); 
 	  if(SA==1&&SB==1) 
           {delay_ms(4); 
 	   break;} 
 	  
 	  delay_ms(4); 
 	  if(SA==1&&SB==1) 
           {delay_ms(4); 
 	   break;} 
 	   goto _err; 
  
          } 
 	 while(1) 
	  {if(SA==1&&SB==1) 
 	   {if(RC5==0)//sprawdznie czy nie odbir z RC5  
 	    {kod=get_rc5();
	    if(kod==0)//blad kodu
	     continue;
             else
	    return(kod);}
 	    continue;} 
             delay_ms(4); 
 	    if(SA==0&&SB==1) 
              {delay_ms(4); 
 	     break;} 
		 
 	    delay_ms(4); 
	    if(SA==0&&SB==1) 
              {delay_ms(4); 
	     break;} 
	     goto _err; 

	 
           } 
	 while(1) 
	  {if(SA==0&&SB==1)  
	   {if(RC5==0)//sprawdznie czy nie odbir z RC5  
 	   {kod=get_rc5();
	 if(kod==0)//blad kodu
	 continue;
         else
	 return(kod);}
	   continue;} 
  
	   delay_ms(4); 
  
	   if(SA==0&&SB==0) 
             {delay_ms(4); 
	    return(0);}//kod impulsatora

	    delay_ms(4); 
	    if(SA==0&&SB==0) 
             {delay_ms(4); 
	    return(0);}//kod impulsatora
	    else 
	     goto _err; 	     
	  } 
	} 
	if(SA==0&&SB==1) 
	{
 	 delay_ms(4); 
  	 while(1) 
 	 {if(SA==0&&SB==1) 
 	  {if(RC5==0) 
 	  {kod=get_rc5();////sprawdznie czy nie odbir z RC5 
	  if(kod==0)//bd kodu
	  continue;
          else
	  return(kod);}
 	  continue;} 
 	   
 	  if(SA==1&&SB==1) 
           {delay_ms(4); 
 	   break;} 
 	 
 	  delay_ms(4); 
 	  if(SA==1&&SB==1) 
           {delay_ms(4); 
 	   break;} 
 	   goto _err; 
  
          } 
 	 while(1) 
 	  {if(SA==1&&SB==1)
	   {if(RC5==0)//sprawdznie czy nie odbir z RC5  
 	   {kod=get_rc5();
	   if(kod==0)//bd kodu
	   continue;
           else
	   return(kod);}

 	    continue;}             	   
            delay_ms(4); 
 	   if(SA==1&&SB==0) 
            {delay_ms(4); 
 	    break;} 

 	    goto _err; 
           } 
  
 	 while(1)  
 	  {if(SA==1&&SB==0) 
 	   {if(RC5==0)//sprawdznie czy nie odbir z RC5  
 	   {kod=get_rc5();
	 if(kod==0)//bd kodu
	 continue;
         else
	 return(kod);}
 	   continue;} 
             
 	   if(SA==0&&SB==0) 
             {delay_ms(4); 
 	    return(8);}//kod impulsatora  	    
            delay_ms(4); 
 	   if(SA==0&&SB==0) 
             {delay_ms(4); 

 	    return(8);}//kod impulsatora 
 	   goto _err; 
           } 
 	  } 
 	 } 
 }
//**********************************************************************
//procedura wpisania argumentu  vol  do DS1801 
//**********************************************************************
void wr_pot(int vol)
{
int i,vol_t,vol_tt;
	
	vol_tt=vol;
  	RST=1;
	for(i=0;i<8;i++)//pierwszy potencjometr
        {
	 CL=0;//zegar =0
	 vol_t=vol;
	 vol_t=vol_t&0x01;
	  if(vol_t==1)//wpisywaniw bitow z vol do wyjscia DQ
	   DQ=1;
	  else
	   DQ=0;
	  CL=1; //wpis danych
          vol=vol>>1;	
        }
	vol=vol_tt;
	for(i=0;i<8;i++)//drugi potencjometr
        {
	 CL=0;//zegar =0
	 vol_t=vol;
	 vol_t=vol_t&0x01;
	  if(vol_t==1)//wpisywaniw bitow z vol do wyjscia DQ
	   DQ=1;
	  else
	   DQ=0;
	  CL=1; //wpis danych
          vol=vol>>1;	
        }
	
	 
	RST=0;//koniec transmisji	 				 			
                        	          
		      		      
    			     }

void wys_dzies(char wartosc,char poz)
{
char ldzies,ljedn;
	pozycja(poz); 
	ldzies=wartosc/10;
	wr_data(ldzies+0x30);
	ldzies=ldzies*10;
	wartosc=wartosc-ldzies;	
	wr_data(wartosc+0x30);
	
}
//**********************************************************************
//procedura zapisania do wewntrznej pamici EERPOM
//**********************************************************************
void wr_eeprom(char adres,char dana)
{	
	EEADR=adres;
	EEDATA=dana;
	GIE=0;
	WREN=1;
	EECON2=0x55;
	EECON2=0xaa;
	WR=1;
	GIE=1;
	while(WR==1);
}
//**********************************************************************
//procedura odczytania z wewnetrznej pamici EEPROM
//**********************************************************************
char rd_eeprom(char adres)
{
	EEADR=adres;
	RD=1;
	return(EEDATA);
}

void pozycja(int poz)
{	
  wr_cmd(poz|0x80);//zapisz adres	
}

void inic_lcd()
{
	RW=0;
	delay_ms(50);//opoznienie 50msek
	RS=0;//rejestr IR
	EN=1;
	dane_lcd(3);//ustaw 3 na RA0...RA3
	EN=0;
	delay_ms(6);
	EN=1;
	#asm
	nop
	nop
	nop
	#endasm
	EN=0;
	delay_ms(1);
	EN=1;
	#asm
	nop
	nop
	nop
	#endasm
	EN=0;
	delay_ms(1);
	
	wr_cmd(0x28);//function set
	wr_cmd(8);//display off
	wr_cmd(1);//display clear
	wr_cmd(6);//entry mod
	wr_cmd(0x0c);//display on
}
void wr_cmd(int cmd)
{
	RS=0;
	wr_lcd(cmd);
}
void wr_data(int data)
{
	RS=1;
	wr_lcd(data);
}
void wr_lcd(int dana)
{
int TMP;
	TMP=dana;
	EN=1;	
	dane_lcd(TMP);//bardziej znaczacy polbajt
	EN=0;
	#asm
	nop;//wpisanie do modulu
	nop;
	#endasm
	EN=1;
	#asm
	swapf TMP,f;
	#endasm
	dane_lcd(TMP);//mniej znaczacy polbajt
	EN=0;
	if(RS==1)
	delay_ms(1);
	else
	delay_ms(3);
}

void dane_lcd(int dana)
{
	dana=dana&0xf0;
	PORTB=PORTB&0x0f;
	PORTB=PORTB|dana;
}

void wys_volume(char poz)
{
char znak;
char i;

	pozycja(poz);  
	for(i=0;i<12;i++)
	{znak=volume(i);
	wr_data(znak);}
}
void delay_ms(char msek)
{
	OPTION=1;
	do{
	TMR0=0;
	while(TMR0<125)
	;}
	while(--msek>0);
	
	
}	


